#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdint.h>
#include <stdlib.h>

int main(){
    FILE *fd;
    size_t size, i;
    uint8_t *data;
    int res;
    
    fd = fopen("list.txt", "rb");
    if(!fd){
        fprintf(stderr, "Failed to open list.txt (%s)", strerror(errno));
        return -1;
    }
    
    fseek(fd, 0, SEEK_END);
    size = ftell(fd);
    if(size < 4){
        fclose(fd);
        fprintf(stderr, "list.txt is too small.");
        return -1;
    }
    fseek(fd, 0, SEEK_SET);

    data = malloc(size);
    if(!size){
        fclose(fd);
        fprintf(stderr, "Failed to allocate memory.");
        return -1;
    }
    
    res = fread(data, 1, size, fd);
    fclose(fd);
    if(res != size){
        fprintf(stderr, "The input file could not be read.");
        return -1;
    }
    
    i = 0;
    do {
        uint32_t address, numbers[4];
        sscanf(data, "%02X %02X %02X %02X", numbers+0, numbers+1, numbers+2, numbers+3);
        address = numbers[0] | (numbers[1] << 8) | (numbers[2] << 16) | (numbers[3] << 24);
        printf("|-\n|0x%04x\n|\n|0x%08X\n", ++i, address);
        
        data += 11;
    } while(*data++ != '*');
    
    return 0;
}